<template>

  <Head>
    <title>Edit Category - GreenK Cashier</title>
  </Head>
  <main class="c-main">
    <div class="container-fluid">
      <div class="fade-in">
        <div class="row">
          <div class="col-md-12">
            <div class="card border-0 rounded-3 shadow">
              <div class="card-header bg-primary text-white">
                <span class="font-weight-bold"><i class="fa fa-folder me-2"></i>
                  EDIT CATEGORY
                </span>
              </div>
              <div class="card-body">
                <!-- form create category -->
                <form @submit.prevent="submit">
                  <!-- image -->
                  <div class="mb-3">
                    <label class="fw-bold">Image</label>
                    <input type="file" class="form-control" @input="form.image = $event.target.files[0]"
                      :class="{ 'is-invalid': errors.image }">
                  </div>
                  <div v-if="errors.image" class="text-danger mb-3" style="margin-top: -20px">
                    <small><strong>{{ errors.image }}</strong></small>
                  </div>

                  <!-- category -->
                  <div class="mb-3">
                    <label class="fw-bold">Category Name</label>
                    <input type="text" v-model="form.name" class="form-control" :class="{ 'is-invalid': errors.name }"
                      placeholder="Category Name">
                  </div>
                  <div v-if="errors.name" class="text-danger mb-3" style="margin-top: -20px">
                    <small><strong>{{ errors.name }}</strong></small>
                  </div>

                  <!-- description -->
                  <div class="mb-3">
                    <label class="fw-bold">Description</label>
                    <textarea v-model="form.description" cols="30" rows="10" class="form-control"
                      :class="{ 'is-invalid': errors.description }" placeholder="Description"></textarea>
                  </div>
                  <div v-if="errors.description" class="text-danger mb-3" style="margin-top: -20px">
                    <small><strong>{{ errors.description }}</strong></small>
                  </div>
                  <div class="row">
                    <div class="col-12">
                      <button class="btn btn-primary shadow-sm rounded" type="submit">Update</button>
                    </div>
                  </div>
                </form>

              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </main>
</template>

<script>
// import layout
import LayoutApp from '../../../Layouts/App.vue';

// import head and Link form inertia
import { Head, Link } from '@inertiajs/vue3';

// import reactive from vue
import { reactive } from 'vue';

// import inertia adapter
import { router } from '@inertiajs/vue3';

// import sweetalert
import Swal from 'sweetalert2';

export default {
  // layout
  layout: LayoutApp,

  // register components
  components: {
    Head, Link
  },

  // props
  props: {
    errors: Object,
    category: Object,
  },

  // composition API
  setup(props) {
    // define form with reactive
    const form = reactive({
      image: '',
      name: props.category.name,
      description: props.category.description,
    });

    // method submit
    const submit = () => {
      // send data to server
      router.post(`/apps/categories/${props.category.slug}`, {
        // data
        _method: 'PUT',
        image: form.image,
        name: form.name,
        description: form.description
      }, {
        onSuccess: () => {
          //show success alert
          Swal.fire({
            title: 'Updated!',
            text: 'Category has been updated.',
            icon: 'success',
            showConfirmButton: false,
            timer: 2000
          });
        },
      });
    }

    // return
    return {
      form,
      submit,
    }
  }
}
</script>

<style>

</style>